#ifndef INC_MYSQL_BACKEND_H
#define INC_MYSQL_BACKEND_H

#include "../config.h"

#if HAVE_LIBMYSQL

#include <mysql/mysql.h>
#include <mysql/errmsg.h>

extern MYSQL *mysql_con;

char sqlbe_init( // returns 0 on success
		const char *hostname,
		const char *user,
		const char *pass,
		const char *dbname
	);
char sqlbe_query(const char *query_str); // 0 on success
char sqlbe_connect(); // 0 on success
char sqlbe_reconnect(); // 0 on success
void sqlbe_cleanup();
char sqlbe_connected(); // bool, 0==false
char sqlbe_available(); // bool
char sqlbe_initialized(); // bool

#endif // HAVE_LIBMYSQL
#endif // INC_MYSQL_BACKEND_H
